Index: main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 7112)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 7114)
@@ -1448,11 +1448,21 @@
 # Pages for students only
 
-class StudentBaseEditActionButton(ManageActionButton):
+class StudentPasswordActionButton(ManageActionButton):
     grok.order(1)
     grok.context(IStudent)
     grok.view(StudentBaseDisplayFormPage)
     grok.require('waeup.handleStudent')
+    icon = 'actionicon_key.png'
     text = 'Change password'
-    target = 'bedit'
+    target = 'change_password'
+
+class StudentPassportActionButton(ManageActionButton):
+    grok.order(1)
+    grok.context(IStudent)
+    grok.view(StudentBaseDisplayFormPage)
+    grok.require('waeup.handleStudent')
+    icon = 'actionicon_portrait.png'
+    text = 'Change portrait'
+    target = 'change_portrait'
 
 class StudentPasswordSetting(grok.Adapter):
@@ -1481,12 +1491,10 @@
     password = property(getPassword, setPassword)
 
-class StudentBaseEditFormPage(WAeUPEditFormPage):
-    """ View to edit student base data by student
-    """
-    grok.context(IStudent)
-    grok.name('bedit')
-    grok.require('waeup.handleStudent')
-    #form_fields = grok.AutoFields(IStudentBaseEdit).omit(
-    #    'student_id', 'reg_number', 'matric_number')
+class StudentPasswordFormPage(WAeUPEditFormPage):
+    """ View to edit the password by student
+    """
+    grok.context(IStudent)
+    grok.name('change_password')
+    grok.require('waeup.handleStudent')
     form_fields = grok.AutoFields(IStudentPasswordSetting)
     grok.template('baseeditpage')
@@ -1496,5 +1504,5 @@
 
     def update(self):
-        super(StudentBaseEditFormPage, self).update()
+        super(StudentPasswordFormPage, self).update()
         self.wf_info = IWorkflowInfo(self.context)
         return
@@ -1524,4 +1532,15 @@
         return
 
+class StudentFilesUploadPage(WAeUPPage):
+    """ View to upload files by student
+    """
+    grok.context(IStudent)
+    grok.name('change_portrait')
+    grok.require('waeup.handleStudent')
+    grok.template('filesuploadpage')
+    label = 'Upload portrait'
+    title = 'Base Data'
+    pnav = 4
+
 class StudentClearanceStartActionButton(ManageActionButton):
     grok.order(1)
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/filesuploadpage.pt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/filesuploadpage.pt	(revision 7114)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/filesuploadpage.pt	(revision 7114)
@@ -0,0 +1,9 @@
+<h2 i18n:translate=""
+    tal:condition="view/label"
+    tal:content="view/label">Label</h2>
+
+<table class="zebra">
+  <tbody>
+    <tal:files content="structure provider:files" />
+  </tbody>
+</table>
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py	(revision 7112)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py	(revision 7114)
@@ -65,10 +65,4 @@
     """Data needed for password setting.
     """
-    name = schema.TextLine(
-        title = u'Full Name',
-        default = u'Nobody',
-        required = True,
-        readonly = True
-        )
 
     password = schema.Password(
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_authentication.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_authentication.py	(revision 7112)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_authentication.py	(revision 7114)
@@ -5,5 +5,5 @@
 ## $Id$
 ## 
-## Copyright (C) 2011 Uli Fouquet
+## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
 ## This program is free software; you can redistribute it and/or modify
 ## it under the terms of the GNU General Public License as published by
@@ -173,4 +173,4 @@
         self.assertRaises(
             Unauthorized,
-            self.browser.open, self.student_path + '/bedit')
+            self.browser.open, self.student_path + '/change_password')
         return
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/viewlets.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/viewlets.py	(revision 7112)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/viewlets.py	(revision 7114)
@@ -10,5 +10,5 @@
     StudentClearanceDisplayFormPage, StudentClearanceManageFormPage,
     write_log_message, StudentBaseManageFormPage, StudentBaseDisplayFormPage,
-    StudentBaseEditFormPage)
+    StudentFilesUploadPage)
 from waeup.sirp.students.interfaces import IStudent, IStudentClearance
 
@@ -325,5 +325,5 @@
     """Passport upload viewlet for students.
     """
-    grok.view(StudentBaseEditFormPage)
+    grok.view(StudentFilesUploadPage)
     grok.require('waeup.handleStudent')
 