Index: main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_browser.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_browser.py	(revision 7114)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_browser.py	(revision 7122)
@@ -372,5 +372,5 @@
         self.browser.open(self.edit_clearance_student_path)
         pseudo_image = StringIO('I pretend to be a graphics file')
-        ctrl = self.browser.getControl(name='birth_certificate')
+        ctrl = self.browser.getControl(name='birthcertificateuploadmanage')
         file_ctrl = ctrl.mech_control
         file_ctrl.add_file(pseudo_image, filename='my_birth_certificate.jpg')
@@ -382,12 +382,14 @@
         # ... but the correct upload submit button does
         pseudo_image = StringIO('I pretend to be a graphics file')
-        ctrl = self.browser.getControl(name='birth_certificate')
+        ctrl = self.browser.getControl(name='birthcertificateuploadmanage')
         file_ctrl = ctrl.mech_control
         file_ctrl.add_file(pseudo_image, filename='my_birth_certificate.jpg')
-        self.browser.getControl(name='upload_birth_certificate').click()
+        self.browser.getControl(
+            name='upload_birthcertificateuploadmanage').click()
         # There is a correct <img> link included
         self.assertTrue(
             '<a target="image" href="birth_certificate.jpg">'
             in self.browser.contents)
+
         # Browsing the link shows a real image
         self.browser.open('birth_certificate.jpg')
@@ -399,30 +401,34 @@
         photo_content = 'A' * 1024 * 151  # A string of 21 KB size
         pseudo_image = StringIO(photo_content)
-        ctrl = self.browser.getControl(name='birth_certificate')
+        ctrl = self.browser.getControl(name='birthcertificateuploadmanage')
         file_ctrl = ctrl.mech_control
         file_ctrl.add_file(pseudo_image, filename='my_birth_certificate.jpg')
-        self.browser.getControl(name='upload_birth_certificate').click()
+        self.browser.getControl(
+            name='upload_birthcertificateuploadmanage').click()
         self.assertTrue(
             'Uploaded file is too big' in self.browser.contents)
         # File names must meet several conditions
         pseudo_image = StringIO('I pretend to be a graphics file')
-        ctrl = self.browser.getControl(name='birth_certificate')
+        ctrl = self.browser.getControl(name='birthcertificateuploadmanage')
         file_ctrl = ctrl.mech_control
         file_ctrl.add_file(pseudo_image, filename='my.photo.jpg')
-        self.browser.getControl(name='upload_birth_certificate').click()
+        self.browser.getControl(
+            name='upload_birthcertificateuploadmanage').click()
         self.assertTrue('File name contains more than one dot'
             in self.browser.contents)
-        ctrl = self.browser.getControl(name='birth_certificate')
+        ctrl = self.browser.getControl(name='birthcertificateuploadmanage')
         file_ctrl = ctrl.mech_control
         file_ctrl.add_file(pseudo_image, filename='my_birth_certificate')
-        self.browser.getControl(name='upload_birth_certificate').click()
+        self.browser.getControl(
+            name='upload_birthcertificateuploadmanage').click()
         self.assertTrue('File name has no extension' in self.browser.contents)
-        ctrl = self.browser.getControl(name='birth_certificate')
+        ctrl = self.browser.getControl(name='birthcertificateuploadmanage')
         file_ctrl = ctrl.mech_control
         file_ctrl.add_file(pseudo_image, filename='my_birth_certificate.bmp')
-        self.browser.getControl(name='upload_birth_certificate').click()
+        self.browser.getControl(
+            name='upload_birthcertificateuploadmanage').click()
         self.assertTrue('.jpg file extension expected' in self.browser.contents)
         # Managers can delete files
-        self.browser.getControl(name='delete_birth_certificate').click()
+        self.browser.getControl(name='delete_birthcertificateuploadmanage').click()
         self.assertTrue(
             'File birth_certificate.jpg deleted'
@@ -431,19 +437,22 @@
         self.browser.open(self.edit_clearance_student_path)
         pseudo_image = StringIO('I pretend to be a graphics file')
-        ctrl = self.browser.getControl(name='birth_certificate')
+        ctrl = self.browser.getControl(name='birthcertificateuploadmanage')
         file_ctrl = ctrl.mech_control
         file_ctrl.add_file(pseudo_image, filename='my_acceptance_letter.jpg')
-        self.browser.getControl(name='upload_acceptance_letter').click()
+        self.browser.getControl(
+            name='upload_acceptanceletteruploadmanage').click()
         self.assertFalse(
             '<a target="image" href="acceptance_letter.jpg">'
             in self.browser.contents)
-        ctrl = self.browser.getControl(name='acceptance_letter')
+        ctrl = self.browser.getControl(name='acceptanceletteruploadmanage')
         file_ctrl = ctrl.mech_control
         file_ctrl.add_file(pseudo_image, filename='my_acceptance_letter.jpg')
-        self.browser.getControl(name='upload_acceptance_letter').click()
+        self.browser.getControl(
+            name='upload_acceptanceletteruploadmanage').click()
         self.assertTrue(
             '<a target="image" href="acceptance_letter.jpg">'
             in self.browser.contents)
-        self.browser.getControl(name='delete_acceptance_letter').click()
+        self.browser.getControl(
+            name='delete_acceptanceletteruploadmanage').click()
         self.assertTrue(
             'File acceptance_letter.jpg deleted'