Index: WAeUP_SRP/trunk/skins/waeup_epayment/interswitch_cb.py
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_epayment/interswitch_cb.py	(revision 7069)
+++ WAeUP_SRP/trunk/skins/waeup_epayment/interswitch_cb.py	(revision 7130)
@@ -43,5 +43,5 @@
 
 referer = request.get('HTTP_REFERER','none')
-real_ip = request.get('HTTP_X_REAL_IP',"none")  
+real_ip = request.get('HTTP_X_REAL_IP',"none")
 logger.info('%s, callback referer = %s, IP = %s' % (student_id,referer,real_ip))
 
@@ -86,27 +86,27 @@
     wftool.doActionFor(context,'open')
 pay_doc = context.getContent()
-resp = pd['resp_code']  
-
-if  resp == '00':
-    try:
-        amount = int(getattr(pay_doc,'amount',0))
-        try:
-            surcharge = int(getattr(pay_doc,'surcharge',0))
-        except:
-            surcharge = 0
-        resp_approved_amount = int(pd['resp_approved_amount'])
-        #set_trace()
-        if not ontest and amount + surcharge != resp_approved_amount:
-            logger.info('Warning: %s, approved amount %s and authorized amount %s are different for payment %s of %s' % (member,resp_approved_amount,amount+surcharge,context.getId(),student_id))
-            pd['status'] = 'failed'
-            pd['resp_desc'] = 'Warning: approved amount in callback does not match!'
-            resp = ''
-        else:
-            pass
-    except:
-        logger.info('%s: approved amount could not be verified for payment %s of %s' % (member,context.getId(),student_id))
-        pd['status'] = 'failed'
-        pd['resp_desc'] = 'Warning: approved amount could not be verified!'
-        resp = ''    
+resp = pd['resp_code']
+
+#if  resp == '00':
+#    try:
+#        amount = int(getattr(pay_doc,'amount',0))
+#        try:
+#            surcharge = int(getattr(pay_doc,'surcharge',0))
+#        except:
+#            surcharge = 0
+#        resp_approved_amount = int(pd['resp_approved_amount'])
+#        #set_trace()
+#        if not ontest and amount + surcharge != resp_approved_amount:
+#            logger.info('Warning: %s, approved amount %s and authorized amount %s are different for payment %s of %s' % (member,resp_approved_amount,amount+surcharge,context.getId(),student_id))
+#            pd['status'] = 'failed'
+#            pd['resp_desc'] = 'Warning: approved amount in callback does not match!'
+#            resp = ''
+#        else:
+#            pass
+#    except:
+#        logger.info('%s: approved amount could not be verified for payment %s of %s' % (member,context.getId(),student_id))
+#        pd['status'] = 'failed'
+#        pd['resp_desc'] = 'Warning: approved amount could not be verified!'
+#        resp = ''
 
 pay_doc.edit(mapping = pd)
@@ -122,5 +122,5 @@
 next_previous_verdict = next_info['next_previous_verdict']
 if  resp == '00':
-    if pay_doc.category == 'schoolfee':  
+    if pay_doc.category == 'schoolfee':
         if context.getStudentReviewState() == "school_fee_paid":
             logger.info('%s paid school_fee in state school_fee_paid' % (student_id))
@@ -144,5 +144,5 @@
 
     elif pay_doc.category == 'hostel_maintenance':
-        
+
         ## callback function for accommodation_catalog method
         data={}
@@ -152,6 +152,6 @@
         data['acco_maint_pay_id'] = context.getId()
         data['reservation_status'] = 'maintenance_fee_paid'
-        context.accommodation_catalog.modifyRecord(**data)        
-        
+        context.accommodation_catalog.modifyRecord(**data)
+
         ## callback function for accommodation object method (deactivated since March 2011)
         #acco_info = context.getAccommodationInfo()
@@ -168,5 +168,5 @@
         #except:
         #    logger.info('%s no workflow action pay_maintenance_fee' % student_id)
-            
+
     elif pay_doc.category == 'acceptance':
         if context.getStudentReviewState() in ('admitted', 'objection_raised'):
@@ -199,3 +199,2 @@
 
 return request.RESPONSE.redirect("%s/waeup_document_view" % context.absolute_url())
-