Index: /main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py	(revision 7135)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py	(revision 7136)
@@ -95,5 +95,5 @@
     grok.context(IApplicantsRoot)
     grok.view(ApplicantsRootPage)
-    grok.require('waeup.manageApplications')
+    grok.require('waeup.manageApplication')
     text = 'Manage application section'
 
@@ -105,5 +105,5 @@
     label = 'Manage application section'
     pnav = 3
-    grok.require('waeup.manageApplications')
+    grok.require('waeup.manageApplication')
     taboneactions = ['Add applicants container', 'Remove selected','Cancel']
     tabtwoactions1 = ['Remove selected local roles']
@@ -170,5 +170,5 @@
 class ApplicantsContainerAddFormPage(WAeUPAddFormPage):
     grok.context(IApplicantsRoot)
-    grok.require('waeup.manageApplications')
+    grok.require('waeup.manageApplication')
     grok.name('add')
     grok.template('applicantscontaineraddpage')
@@ -276,5 +276,5 @@
     grok.context(IApplicantsContainer)
     grok.view(ApplicantsContainerPage)
-    grok.require('waeup.manageApplications')
+    grok.require('waeup.manageApplication')
     text = 'Manage applicants container'
 
@@ -300,5 +300,5 @@
     form_fields['startdate'].custom_widget = FriendlyDateWidget('le')
     form_fields['enddate'].custom_widget = FriendlyDateWidget('le')
-    grok.require('waeup.manageApplications')
+    grok.require('waeup.manageApplication')
 
     @property
@@ -467,5 +467,5 @@
     """
     grok.context(IApplicantsContainer)
-    grok.require('waeup.manageApplications')
+    grok.require('waeup.manageApplication')
     grok.name('addapplicant')
     grok.template('applicantaddpage')
@@ -582,5 +582,5 @@
 class PDFActionButton(ManageActionButton):
     grok.context(IApplicant)
-    grok.require('waeup.manageApplications')
+    grok.require('waeup.viewApplication')
     icon = 'actionicon_pdf.png'
     text = 'Download application slip'
@@ -592,5 +592,5 @@
     grok.context(IApplicant)
     grok.name('application_slip.pdf')
-    grok.require('waeup.handleApplication')
+    grok.require('waeup.viewApplication')
     form_fields = grok.AutoFields(IApplicant).omit(
         'locked').omit('course_admitted')
@@ -693,5 +693,5 @@
     grok.context(IApplicant)
     grok.view(DisplayApplicant)
-    grok.require('waeup.manageApplications')
+    grok.require('waeup.manageApplication')
     text = 'Manage application record'
     target = 'edit_full'
@@ -721,5 +721,5 @@
     grok.context(IApplicant)
     grok.name('edit_full')
-    grok.require('waeup.manageApplications')
+    grok.require('waeup.manageApplication')
     form_fields = grok.AutoFields(IApplicant)
     form_fields['date_of_birth'].custom_widget = FriendlyDateWidget('le-year')
@@ -849,5 +849,5 @@
     grok.context(IApplicant)
     grok.view(EditApplicantFull)
-    grok.require('waeup.manageApplications')
+    grok.require('waeup.manageApplication')
     icon = 'actionicon_view.png'
     text = 'View application record'
Index: /main/waeup.sirp/trunk/src/waeup/sirp/applicants/permissions.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/applicants/permissions.py	(revision 7135)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/applicants/permissions.py	(revision 7136)
@@ -33,6 +33,6 @@
     grok.name('waeup.viewApplication')
 
-class ManageApplications(grok.Permission):
-    grok.name('waeup.manageApplications')
+class ManageApplication(grok.Permission):
+    grok.name('waeup.manageApplication')
 
 # Local role
@@ -46,3 +46,3 @@
     grok.name('waeup.ApplicationsOfficer')
     grok.title(u'Applications Officer')
-    grok.permissions('waeup.manageApplications', 'waeup.viewApplication')
+    grok.permissions('waeup.manageApplication', 'waeup.viewApplication')
Index: /main/waeup.sirp/trunk/src/waeup/sirp/permissions.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/permissions.py	(revision 7135)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/permissions.py	(revision 7136)
@@ -46,5 +46,4 @@
     grok.name('waeup.local.ClearanceOfficer')
     grok.title(u'Clearance Officer')
-    # to be further defined
     grok.permissions('waeup.View', 'waeup.Public')
 
@@ -52,5 +51,4 @@
     grok.name('waeup.local.CourseAdviser')
     grok.title(u'Course Adviser')
-    # to be further defined
     grok.permissions('waeup.View', 'waeup.Public')
 
@@ -69,5 +67,5 @@
                      'waeup.managePortalConfiguration',
                      'waeup.manageApplications', 'waeup.handleApplication',
-                     'waeup.viewStudent', 'waeup.manageStudents',
+                     'waeup.viewStudent', 'waeup.manageStudent', 'clearStudent'
                      'waeup.viewHostels', 'waeup.manageHostels')
 
Index: /main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 7135)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 7136)
@@ -260,5 +260,5 @@
     grok.context(IStudentsContainer)
     grok.view(StudentsContainerPage)
-    grok.require('waeup.manageStudents')
+    grok.require('waeup.manageStudent')
     text = 'Manage student section'
 
@@ -269,5 +269,5 @@
     grok.context(IStudentsContainer)
     grok.name('manage')
-    grok.require('waeup.manageStudents')
+    grok.require('waeup.manageStudent')
     grok.template('containermanagepage')
     pnav = 4
@@ -317,5 +317,5 @@
     grok.context(IStudentsContainer)
     grok.view(StudentsContainerManagePage)
-    grok.require('waeup.manageStudents')
+    grok.require('waeup.manageStudent')
     text = 'Add student'
     target = 'addstudent'
@@ -325,5 +325,5 @@
     """
     grok.context(IStudentsContainer)
-    grok.require('waeup.manageStudents')
+    grok.require('waeup.manageStudent')
     grok.name('addstudent')
     grok.template('studentaddpage')
@@ -367,5 +367,5 @@
     grok.context(IStudent)
     grok.view(StudentBaseDisplayFormPage)
-    grok.require('waeup.manageStudents')
+    grok.require('waeup.manageStudent')
     text = 'Manage'
     target = 'manage_base'
@@ -376,5 +376,5 @@
     grok.context(IStudent)
     grok.name('manage_base')
-    grok.require('waeup.manageStudents')
+    grok.require('waeup.manageStudent')
     form_fields = grok.AutoFields(IStudentBase).omit('student_id')
     grok.template('basemanagepage')
@@ -463,5 +463,5 @@
     grok.context(IStudent)
     grok.view(StudentClearanceDisplayFormPage)
-    grok.require('waeup.manageStudents')
+    grok.require('waeup.manageStudent')
     text = 'Manage'
     target = 'edit_clearance'
@@ -472,5 +472,5 @@
     grok.context(IStudent)
     grok.name('edit_clearance')
-    grok.require('waeup.manageStudents')
+    grok.require('waeup.manageStudent')
     grok.template('clearanceeditpage')
     form_fields = grok.AutoFields(IStudentClearance)
@@ -508,5 +508,5 @@
     grok.context(IStudent)
     grok.view(StudentPersonalDisplayFormPage)
-    grok.require('waeup.manageStudents')
+    grok.require('waeup.manageStudent')
     text = 'Manage'
     target = 'edit_personal'
@@ -552,5 +552,5 @@
     grok.context(IStudentStudyCourse)
     grok.view(StudyCourseDisplayFormPage)
-    grok.require('waeup.manageStudents')
+    grok.require('waeup.manageStudent')
     text = 'Manage'
     target = 'manage'
@@ -561,5 +561,5 @@
     grok.context(IStudentStudyCourse)
     grok.name('manage')
-    grok.require('waeup.manageStudents')
+    grok.require('waeup.manageStudent')
     grok.template('studycoursemanagepage')
     form_fields = grok.AutoFields(IStudentStudyCourse)
@@ -684,5 +684,5 @@
     grok.context(IStudentStudyLevel)
     grok.view(StudyLevelDisplayFormPage)
-    grok.require('waeup.manageStudents')
+    grok.require('waeup.manageStudent')
     text = 'Manage'
     target = 'manage'
@@ -693,5 +693,5 @@
     grok.context(IStudentStudyLevel)
     grok.name('manage')
-    grok.require('waeup.manageStudents')
+    grok.require('waeup.manageStudent')
     grok.template('studylevelmanagepage')
     form_fields = grok.AutoFields(IStudentStudyLevel)
@@ -752,5 +752,5 @@
     grok.context(IStudentStudyLevel)
     grok.name('add')
-    grok.require('waeup.manageStudents')
+    grok.require('waeup.manageStudent')
     label = 'Add course ticket'
     form_fields = grok.AutoFields(ICourseTicketAdd).omit(
@@ -811,5 +811,5 @@
     grok.context(ICourseTicket)
     grok.view(CourseTicketDisplayFormPage)
-    grok.require('waeup.manageStudents')
+    grok.require('waeup.manageStudent')
     text = 'Manage'
     target = 'manage'
@@ -820,5 +820,5 @@
     grok.context(ICourseTicket)
     grok.name('manage')
-    grok.require('waeup.manageStudents')
+    grok.require('waeup.manageStudent')
     form_fields = grok.AutoFields(ICourseTicket)
     grok.template('courseticketmanagepage')
@@ -932,5 +932,5 @@
 #    grok.context(IStudentPaymentsContainer)
 #    grok.view(PaymentsDisplayFormPage)
-#    grok.require('waeup.manageStudents')
+#    grok.require('waeup.manageStudent')
 #    text = 'Manage payments'
 #    target = 'manage'
Index: /main/waeup.sirp/trunk/src/waeup/sirp/students/permissions.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/students/permissions.py	(revision 7135)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/students/permissions.py	(revision 7136)
@@ -33,6 +33,9 @@
     grok.name('waeup.uploadStudentFile')
 
-class ManageStudents(grok.Permission):
-    grok.name('waeup.manageStudents')
+class ManageStudent(grok.Permission):
+    grok.name('waeup.manageStudent')
+
+class ClearStudent(grok.Permission):
+    grok.name('waeup.clearStudent')
 
 # Local role
@@ -52,4 +55,4 @@
     grok.title(u'Students Officer')
     grok.permissions('waeup.View', 'waeup.Public',
-                     'waeup.viewStudent', 'waeup.manageStudents',
+                     'waeup.viewStudent', 'waeup.manageStudent',
                      'waeup.payStudent', 'waeup.uploadStudentFile')
Index: /main/waeup.sirp/trunk/src/waeup/sirp/students/viewlets.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/students/viewlets.py	(revision 7135)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/students/viewlets.py	(revision 7136)
@@ -340,5 +340,5 @@
     grok.context(IStudent)
     grok.view(StudentBaseManageFormPage)
-    grok.require('waeup.manageStudents')
+    grok.require('waeup.manageStudent')
     grok.template('imageupload')
     label = u'Passport Picture (jpg only):'