Index: main/waeup.custom/trunk/src/waeup/custom/interfaces.py
===================================================================
--- main/waeup.custom/trunk/src/waeup/custom/interfaces.py	(revision 7144)
+++ main/waeup.custom/trunk/src/waeup/custom/interfaces.py	(revision 7145)
@@ -11,5 +11,5 @@
 
     school_fee_base = schema.Int(
-        title = u'School Fee',
+        title = u'School Fee (ignored)',
         default = 0,
         )
Index: main/waeup.custom/trunk/src/waeup/custom/students/browser.py
===================================================================
--- main/waeup.custom/trunk/src/waeup/custom/students/browser.py	(revision 7144)
+++ main/waeup.custom/trunk/src/waeup/custom/students/browser.py	(revision 7145)
@@ -3,5 +3,5 @@
 from zope.component import createObject
 from waeup.sirp.students.browser import OnlinePaymentAddFormPage
-from waeup.custom.students.utils import getPaymentDetails
+from waeup.custom.students.utils import get_payment_details
 
 class OnlinePaymentAddFormPage(OnlinePaymentAddFormPage):
@@ -9,4 +9,4 @@
     """
 
-    def getPaymentDetails(self, category, student):
-        return getPaymentDetails(category, student)
+    def get_payment_details(self, category, student):
+        return get_payment_details(category, student)
Index: main/waeup.custom/trunk/src/waeup/custom/students/utils.py
===================================================================
--- main/waeup.custom/trunk/src/waeup/custom/students/utils.py	(revision 7144)
+++ main/waeup.custom/trunk/src/waeup/custom/students/utils.py	(revision 7145)
@@ -3,5 +3,5 @@
 from waeup.sirp.students.workflow import CLEARED, RETURNING
 
-def getPaymentDetails(category, student):
+def get_payment_details(category, student):
     d = {}
     d['surcharge_1'] = d['surcharge_2'] = d['surcharge_3'] = 0
Index: main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py	(revision 7144)
+++ main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py	(revision 7145)
@@ -797,5 +797,5 @@
     title = u'Your Application Form'
 
-    def emitLockMessage(self):
+    def emit_lock_message(self):
         self.flash('The requested form is locked (read-only).')
         self.redirect(self.url(self.context))
@@ -804,5 +804,5 @@
     def update(self):
         if self.context.locked:
-            self.emitLockMessage()
+            self.emit_lock_message()
             return
         datepicker.need() # Enable jQuery datepicker in date fields.
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 7144)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 7145)
@@ -52,6 +52,6 @@
 from waeup.sirp.students.vocabularies import StudyLevelSource
 from waeup.sirp.students.utils import (
-    getPaymentDetails, getAccommodationDetails, selectBed,
-    renderPDF, validatePassword)
+    get_payment_details, get_accommodation_details, select_bed,
+    render_pdf, validatePassword)
 from waeup.sirp.browser.resources import toggleall
 from waeup.sirp.authentication import get_principal_role_manager
@@ -77,5 +77,5 @@
     return
 
-def emitLockMessage(view):
+def emit_lock_message(view):
     view.flash('The requested form is locked (read-only).')
     view.redirect(view.url(view.context))
@@ -678,5 +678,5 @@
         studentview = StudentBaseDisplayFormPage(self.context.getStudent(),
             self.request)
-        return renderPDF(self,'Course Registration', 'course_registration.pdf',
+        return render_pdf(self,'Course Registration', 'course_registration.pdf',
             self.context.getStudent, studentview)
 
@@ -951,6 +951,6 @@
     
     # To be sepezified in customization packages
-    def getPaymentDetails(self, category, student):
-        return getPaymentDetails(category, student)
+    def get_payment_details(self, category, student):
+        return get_payment_details(category, student)
 
     @grok.action('Create ticket')
@@ -965,5 +965,5 @@
                 self.redirect(self.url(self.context))
                 return
-        pay_details  = self.getPaymentDetails(
+        pay_details  = self.get_payment_details(
             p_category,student)
         if pay_details['error']:
@@ -1119,5 +1119,5 @@
         studentview = StudentBaseDisplayFormPage(self.context.getStudent(),
             self.request)
-        return renderPDF(self,'Payment', 'payment_receipt.pdf',
+        return render_pdf(self,'Payment', 'payment_receipt.pdf',
             self.context.getStudent, studentview)
 
@@ -1229,14 +1229,14 @@
 
     # To be sepezified in customization packages
-    def getAccommodationDetails(self, student):
-        return getAccommodationDetails(student)
+    def get_accommodation_details(self, student):
+        return get_accommodation_details(student)
 
     # To be sepezified in customization packages
-    def selectBed(self, available_beds):
-        return selectBed(available_beds)
+    def select_bed(self, available_beds):
+        return select_bed(available_beds)
 
     def update(self, SUBMIT=None):
         student = self.context.getStudent()
-        acc_details  = self.getAccommodationDetails(student)
+        acc_details  = self.get_accommodation_details(student)
         if not student.state in acc_details['allowed_states']:
             self.flash("You are in the wrong registration state.")
@@ -1275,5 +1275,5 @@
                 entry for entry in entries if entry.owner == NOT_OCCUPIED]
             if available_beds:
-                bed = self.selectBed(available_beds)
+                bed = self.select_bed(available_beds)
                 bed.bookBed(student.student_id)
             else:
@@ -1356,5 +1356,5 @@
         studentview = StudentBaseDisplayFormPage(self.context.getStudent(),
             self.request)
-        return renderPDF(self,'Bed Allocation', 'bed_allocation.pdf',
+        return render_pdf(self,'Bed Allocation', 'bed_allocation.pdf',
             self.context.getStudent, studentview)
 
@@ -1376,10 +1376,10 @@
 
     # To be sepezified in customization packages
-    def getAccommodationDetails(self, student):
-        return getAccommodationDetails(student)
+    def get_accommodation_details(self, student):
+        return get_accommodation_details(student)
 
     # To be sepezified in customization packages
-    def selectBed(self, available_beds):
-        return selectBed(available_beds)
+    def select_bed(self, available_beds):
+        return select_bed(available_beds)
 
     # Relocate student if student parameters have changed or the bed_type
@@ -1387,5 +1387,5 @@
     def update(self):
         student = self.context.getStudent()
-        acc_details  = self.getAccommodationDetails(student)
+        acc_details  = self.get_accommodation_details(student)
         if self.context.bed != None and \
               'reserved' in self.context.bed.bed_type:
@@ -1414,5 +1414,5 @@
                 entry for entry in entries if entry.owner == NOT_OCCUPIED]
             if available_beds:
-                new_bed = self.selectBed(available_beds)
+                new_bed = self.select_bed(available_beds)
                 new_bed.bookBed(student.student_id)
             else:
@@ -1548,5 +1548,5 @@
     def update(self):
         if self.context.getStudent().state != 'admitted':
-            emitLockMessage(self)
+            emit_lock_message(self)
             return
         super(StudentFilesUploadPage, self).update()
@@ -1662,5 +1662,5 @@
     def update(self):
         if self.context.clearance_locked:
-            emitLockMessage(self)
+            emit_lock_message(self)
             return
         return super(StudentClearanceEditFormPage, self).update()
@@ -1819,5 +1819,5 @@
     def update(self):
         if self.context.getStudent().state != 'school fee paid':
-            emitLockMessage(self)
+            emit_lock_message(self)
             return
         super(AddStudyLevelFormPage, self).update()
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/utils.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/utils.py	(revision 7144)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/utils.py	(revision 7145)
@@ -41,5 +41,5 @@
 # To be specified in customization packages, see also the view which
 # calls the function.
-def getPaymentDetails(category, student):
+def get_payment_details(category, student):
     d = {}
     d['p_item'] = u''
@@ -63,5 +63,5 @@
         d['amount'] = academic_session.clearance_fee
     elif category == 'bed_allocation':
-        d['p_item'] = getAccommodationDetails(student)['bt']
+        d['p_item'] = get_accommodation_details(student)['bt']
         d['amount'] = academic_session.booking_fee
     return d
@@ -69,5 +69,5 @@
 # To be specified in customization packages, see also the view which
 # calls the function.
-def getAccommodationDetails(student):
+def get_accommodation_details(student):
     d = {}
     d['error'] = u''
@@ -99,5 +99,5 @@
 # I the standard configuration we select the first bed found,
 # but can also randomize the selection if we like.
-def selectBed(available_beds):
+def select_bed(available_beds):
     return available_beds[0]
 
@@ -110,5 +110,5 @@
         )
 
-def renderStudentData(student, studentview):
+def render_student_data(student, studentview):
     setUpWidgets(studentview, ignore_request=True)
     data = []
@@ -127,5 +127,5 @@
 # To be specified in customization packages, see also view which
 # calls the function.
-def renderPDF(view, subject='', filename='slip.pdf', student=None, studentview=None):
+def render_pdf(view, subject='', filename='slip.pdf', student=None, studentview=None):
     # (0,0),(-1,-1) = whole table
     # (0,0),(0,-1) = first column
@@ -156,5 +156,5 @@
     if student:
         story.append(Spacer(1, 18))
-        studenttable = renderStudentData(student, studentview)
+        studenttable = render_student_data(student, studentview)
         story.append(studenttable)
     story.append(Spacer(1, 18))